/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * eMount
 * http://emount.sourceforge.net/
 * 
 * Copyright (C) Aqueio 2010-2011 <aqueio@yahoo.com>
 * 
 * eMount is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * eMount is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "UtilGui.h"
#include "QDebug.h"

//==============================================================================

UtilGui::UtilGui()
{
}

//==============================================================================

UtilGui::~UtilGui()
{
}

//==============================================================================

void UtilGui::mapCreateDiskImageDlg(	Glib::RefPtr<Gtk::Builder> poRefGlade,
										tCreateDiskImageDlg& tCreateDiskImageDlgItem)
{
	tCreateDiskImageDlgItem.tCreatePlainDiskImageDlgItem.poFSysComboBox = 0;
	tCreateDiskImageDlgItem.tCreatePlainDiskImageDlgItem.poPlaceAfterComboBox = 0;

	tCreateDiskImageDlgItem.poCipherComboBox = 0;
	tCreateDiskImageDlgItem.poCBCComboBox = 0;
	tCreateDiskImageDlgItem.poKeySizeComboBox = 0;
	
	poRefGlade->get_widget("CreateDiskImageDlgSaveAsEntry", 
		tCreateDiskImageDlgItem.tCreatePlainDiskImageDlgItem.poSaveAsEntry);
		
	poRefGlade->get_widget("CreateDiskImageDlgSaveAsBrowseButton", 
		tCreateDiskImageDlgItem.tCreatePlainDiskImageDlgItem.poSaveAsBrowseButton);
	
	poRefGlade->get_widget("CreateDiskImageDlgVolumeLabelEntry", 
		tCreateDiskImageDlgItem.tCreatePlainDiskImageDlgItem.poVolumeLabelEntry);
	
	poRefGlade->get_widget("CreateDiskImageDlgVolumeSizeEntry", 
		tCreateDiskImageDlgItem.tCreatePlainDiskImageDlgItem.poVolumeSizeEntry);
	
	poRefGlade->get_widget("CreateDiskImageDlgMRadioButton", 
		tCreateDiskImageDlgItem.tCreatePlainDiskImageDlgItem.poMRadioButton);
	
	poRefGlade->get_widget("CreateDiskImageDlgGRadioButton", 
		tCreateDiskImageDlgItem.tCreatePlainDiskImageDlgItem.poGRadioButton);
	
	poRefGlade->get_widget("CreateDiskImageDlgAllocFullRadioButton", 
		tCreateDiskImageDlgItem.tCreatePlainDiskImageDlgItem.poAllocFullRadioButton);
		
	poRefGlade->get_widget("CreateDiskImageDlgAllocCompactRadioButton", 
		tCreateDiskImageDlgItem.tCreatePlainDiskImageDlgItem.poAllocCompactRadioButton);
		
	poRefGlade->get_widget("CreatePlainDiskImageDlgAllocCompactRadioButton", 
		tCreateDiskImageDlgItem.tCreatePlainDiskImageDlgItem.poAllocCompactRadioButton);
		
	poRefGlade->get_widget("CreateDiskImageDlgFSysVBox", 
		tCreateDiskImageDlgItem.tCreatePlainDiskImageDlgItem.poFSysVBox);
	
	poRefGlade->get_widget("CreateDiskImageDlgPlaceAfterVBox", 
		tCreateDiskImageDlgItem.tCreatePlainDiskImageDlgItem.poPlaceAfterVBox);
	
	
	poRefGlade->get_widget("CreateDiskImageDlgUsePasswordRadioButton", 
		tCreateDiskImageDlgItem.poUsePasswordRadioButton);
	
	poRefGlade->get_widget("CreateDiskImageDlgUseKeyFileRadioButton", 
		tCreateDiskImageDlgItem.poUseKeyFileRadioButton);
			
	poRefGlade->get_widget("CreateDiskImageDlgKeyFileFileChooser", 
		tCreateDiskImageDlgItem.poKeyFileFileChooser);
		
				
	poRefGlade->get_widget("CreateDiskImageDlgCipherVBox", 
		tCreateDiskImageDlgItem.poCipherVBox);
	
	poRefGlade->get_widget("CreateDiskImageDlgCBCVBox", 
		tCreateDiskImageDlgItem.poCBCVBox);
	
	poRefGlade->get_widget("CreateDiskImageDlgKeySizeVBox", 
		tCreateDiskImageDlgItem.poKeySizeVBox);
		
		
	poRefGlade->get_widget("CreateDiskImageDlgCancelButton", 
		tCreateDiskImageDlgItem.tCreatePlainDiskImageDlgItem.poCancelButton);
	
	poRefGlade->get_widget("CreateDiskImageDlgCreateButton", 
		tCreateDiskImageDlgItem.tCreatePlainDiskImageDlgItem.poCreateButton);
}

//==============================================================================

void UtilGui::mapCreatePlainDiskImageDlg(	Glib::RefPtr<Gtk::Builder> poRefGlade,
											tCreatePlainDiskImageDlg& tCreatePlainDiskImageDlgItem)
{
	tCreatePlainDiskImageDlgItem.poFSysComboBox = 0;
	tCreatePlainDiskImageDlgItem.poPlaceAfterComboBox = 0;

	poRefGlade->get_widget("CreatePlainDiskImageDlgSaveAsEntry", 
		tCreatePlainDiskImageDlgItem.poSaveAsEntry);
		
	poRefGlade->get_widget("CreatePlainDiskImageDlgSaveAsBrowseButton", 
		tCreatePlainDiskImageDlgItem.poSaveAsBrowseButton);
	
	poRefGlade->get_widget("CreatePlainDiskImageDlgVolumeLabelEntry", 
		tCreatePlainDiskImageDlgItem.poVolumeLabelEntry);
	
	poRefGlade->get_widget("CreatePlainDiskImageDlgVolumeSizeEntry", 
		tCreatePlainDiskImageDlgItem.poVolumeSizeEntry);
	
	poRefGlade->get_widget("CreatePlainDiskImageDlgMRadioButton", 
		tCreatePlainDiskImageDlgItem.poMRadioButton);
	
	poRefGlade->get_widget("CreatePlainDiskImageDlgGRadioButton", 
		tCreatePlainDiskImageDlgItem.poGRadioButton);
	
	poRefGlade->get_widget("CreatePlainDiskImageDlgAllocFullRadioButton", 
		tCreatePlainDiskImageDlgItem.poAllocFullRadioButton);
		
	poRefGlade->get_widget("CreatePlainDiskImageDlgAllocCompactRadioButton", 
		tCreatePlainDiskImageDlgItem.poAllocCompactRadioButton);
		
	poRefGlade->get_widget("CreatePlainDiskImageDlgFSysVBox", 
		tCreatePlainDiskImageDlgItem.poFSysVBox);
	
	poRefGlade->get_widget("CreatePlainDiskImageDlgPlaceAfterVBox", 
		tCreatePlainDiskImageDlgItem.poPlaceAfterVBox);
	
	
	poRefGlade->get_widget("CreatePlainDiskImageDlgCancelButton", 
		tCreatePlainDiskImageDlgItem.poCancelButton);
	
	poRefGlade->get_widget("CreatePlainDiskImageDlgCreateButton", 
		tCreatePlainDiskImageDlgItem.poCreateButton);
}

//==============================================================================

void UtilGui::mapCreateVolumeDlg(	Glib::RefPtr<Gtk::Builder> poRefGlade,
									tCreateVolumeDlg& tCreateVolumeDlgItem)
{	
	tCreateVolumeDlgItem.poFSysComboBox = 0;
	tCreateVolumeDlgItem.poPlaceAfterComboBox = 0;
	
	poRefGlade->get_widget("CreateVolumeDlgSourceFileChooser", 
		tCreateVolumeDlgItem.poSourceFileChooser);
	
	poRefGlade->get_widget("CreateVolumeDlgVolumeLabelEntry", 
		tCreateVolumeDlgItem.poVolumeLabelEntry);
		
	poRefGlade->get_widget("CreateVolumeDlgFSysVBox", 
		tCreateVolumeDlgItem.poFSysVBox);
		
	poRefGlade->get_widget("CreateVolumeDlgPlaceAfterVBox", 
		tCreateVolumeDlgItem.poPlaceAfterVBox);
	
	
	poRefGlade->get_widget("CreateVolumeDlgUsePasswordRadioButton", 
		tCreateVolumeDlgItem.poUsePasswordRadioButton);
	
	poRefGlade->get_widget("CreateVolumeDlgUseKeyFileRadioButton", 
		tCreateVolumeDlgItem.poUseKeyFileRadioButton);
			
	poRefGlade->get_widget("CreateVolumeDlgKeyFileFileChooser", 
		tCreateVolumeDlgItem.poKeyFileFileChooser);
		
				
	poRefGlade->get_widget("CreateVolumeDlgCipherVBox", 
		tCreateVolumeDlgItem.poCipherVBox);
	
	poRefGlade->get_widget("CreateVolumeDlgCBCVBox", 
		tCreateVolumeDlgItem.poCBCVBox);
	
	poRefGlade->get_widget("CreateVolumeDlgKeySizeVBox", 
		tCreateVolumeDlgItem.poKeySizeVBox);
		
		
	poRefGlade->get_widget("CreateVolumeDlgCancelButton", 
		tCreateVolumeDlgItem.poCancelButton);
	
	poRefGlade->get_widget("CreateVolumeDlgCreateButton", 
		tCreateVolumeDlgItem.poCreateButton);
}

//==============================================================================

void UtilGui::mapEnlargeVolumeDlg(	Glib::RefPtr<Gtk::Builder> poRefGlade,
									tEnlargeVolumeDlg& tEnlargeVolumeDlgItem)
{		
	poRefGlade->get_widget("EnlargeVolumeDlgSaveAsEntry", 
		tEnlargeVolumeDlgItem.poSaveAsEntry);
	
	poRefGlade->get_widget("EnlargeVolumeDlgVolumeLabelEntry", 
		tEnlargeVolumeDlgItem.poVolumeLabelEntry);
		
	poRefGlade->get_widget("EnlargeVolumeDlgVolumeSizeEntry", 
		tEnlargeVolumeDlgItem.poVolumeSizeEntry);
	
	poRefGlade->get_widget("EnlargeVolumeDlgNewVolumeSizeEntry", 
		tEnlargeVolumeDlgItem.poNewVolumeSizeEntry);
		
	poRefGlade->get_widget("EnlargeVolumeDlgMRadioButton", 
		tEnlargeVolumeDlgItem.poMRadioButton);
	
	poRefGlade->get_widget("EnlargeVolumeDlgGRadioButton", 
		tEnlargeVolumeDlgItem.poGRadioButton);
		
	poRefGlade->get_widget("EnlargeVolumeDlgCancelButton", 
		tEnlargeVolumeDlgItem.poCancelButton);
	
	poRefGlade->get_widget("EnlargeVolumeDlgEnlargeButton", 
		tEnlargeVolumeDlgItem.poEnlargeButton);
}

//==============================================================================

void UtilGui::mapInitVolumeDlg(	Glib::RefPtr<Gtk::Builder> poRefGlade,
								tInitVolumeDlg& tInitVolumeDlgItem)
{	
	tInitVolumeDlgItem.poFSysComboBox = 0;
	tInitVolumeDlgItem.poKeyFileFileChooser = 0;
	
	poRefGlade->get_widget("InitVolumeDlgSaveAsEntry", 
		tInitVolumeDlgItem.poSaveAsEntry);
	
	poRefGlade->get_widget("InitVolumeDlgVolumeLabelEntry", 
		tInitVolumeDlgItem.poVolumeLabelEntry);
		
	poRefGlade->get_widget("InitVolumeDlgFSysVBox", 
		tInitVolumeDlgItem.poFSysVBox);
			
	poRefGlade->get_widget("InitVolumeDlgEncryptedCheckButton", 
		tInitVolumeDlgItem.poEncryptedCheckButton);
	
	poRefGlade->get_widget("InitVolumeDlgUsePasswordRadioButton", 
		tInitVolumeDlgItem.poUsePasswordRadioButton);
	
	poRefGlade->get_widget("InitVolumeDlgUseKeyFileRadioButton", 
		tInitVolumeDlgItem.poUseKeyFileRadioButton);
			
	poRefGlade->get_widget("InitVolumeDlgKeyFileVBox", 
		tInitVolumeDlgItem.poKeyFileVBox);
		
				
	poRefGlade->get_widget("InitVolumeDlgCipherVBox", 
		tInitVolumeDlgItem.poCipherVBox);
	
	poRefGlade->get_widget("InitVolumeDlgCBCVBox", 
		tInitVolumeDlgItem.poCBCVBox);
	
	poRefGlade->get_widget("InitVolumeDlgKeySizeVBox", 
		tInitVolumeDlgItem.poKeySizeVBox);
		
		
	poRefGlade->get_widget("InitVolumeDlgCancelButton", 
		tInitVolumeDlgItem.poCancelButton);
	
	poRefGlade->get_widget("InitVolumeDlgInitButton", 
		tInitVolumeDlgItem.poInitButton);
}
									
//==============================================================================

void UtilGui::mapMountDlg(  Glib::RefPtr<Gtk::Builder> poRefGlade,
							tMountDlg& tMountDlgItem)
{
	tMountDlgItem.poFSysComboBox = 0;
	tMountDlgItem.poPlaceAfterComboBox = 0;
	tMountDlgItem.poSourceFileChooser = 0;
	
	poRefGlade->get_widget("MountDlgSourceVBox", tMountDlgItem.poSourceVBox);
	poRefGlade->get_widget("MountDlgMountPointFileChooser", tMountDlgItem.poMountPointFileChooser);
	poRefGlade->get_widget("MountDlgPermToggleButton", tMountDlgItem.poPermToggleButton);
	poRefGlade->get_widget("MountDlgVolumeLabelEntry", tMountDlgItem.poVolumeLabelEntry);
	poRefGlade->get_widget("MountDlgFSysVBox", tMountDlgItem.poFSysVBox);
	poRefGlade->get_widget("MountDlgReadOnlyCheckButton", tMountDlgItem.poReadOnlyCheckButton);
	poRefGlade->get_widget("MountDlgEncryptedCheckButton", tMountDlgItem.poEncryptedCheckButton);
	poRefGlade->get_widget("MountDlgUsePasswordRadioButton", tMountDlgItem.poUsePasswordRadioButton);
	poRefGlade->get_widget("MountDlgUseKeyFileRadioButton", tMountDlgItem.poUseKeyFileRadioButton);
	poRefGlade->get_widget("MountDlgKeyFileFileChooser", tMountDlgItem.poKeyFileFileChooser);
	poRefGlade->get_widget("MountDlgPlaceAfterVBox", tMountDlgItem.poPlaceAfterVBox);
	
	poRefGlade->get_widget("MountDlgCancelButton", tMountDlgItem.poCancelButton);
	poRefGlade->get_widget("MountDlgAddButton", tMountDlgItem.poAddButton);
	poRefGlade->get_widget("MountDlgMountButton", tMountDlgItem.poMountButton);
}

//==============================================================================

void UtilGui::mapPermDlg(   Glib::RefPtr<Gtk::Builder> poRefGlade,
							tPermDlg& tPermDlgItem)
{
	tPermDlgItem.poOwnerComboBox = 0;
	tPermDlgItem.poGroupComboBox = 0;
	tPermDlgItem.poOwnerPermComboBox = 0;
	tPermDlgItem.poGroupPermComboBox = 0;
	tPermDlgItem.poOtherPermComboBox = 0;
	
	poRefGlade->get_widget("PermDlgSetCheckButton", tPermDlgItem.poSetCheckButton);
	poRefGlade->get_widget("PermDlgOwnerVBox", tPermDlgItem.poOwnerVBox);
	poRefGlade->get_widget("PermDlgGroupVBox", tPermDlgItem.poGroupVBox);
	poRefGlade->get_widget("PermDlgOwnerPermVBox", tPermDlgItem.poOwnerPermVBox);
	poRefGlade->get_widget("PermDlgGroupPermVBox", tPermDlgItem.poGroupPermVBox);
	poRefGlade->get_widget("PermDlgOtherPermVBox", tPermDlgItem.poOtherPermVBox);
	
	poRefGlade->get_widget("PermDlgButton", tPermDlgItem.poButton);
}

//==============================================================================

void UtilGui::mapPropDlg(   Glib::RefPtr<Gtk::Builder> poRefGlade,
							tPropDlg& tPropDlgItem)
{
	tPropDlgItem.tMountItem.poSourceVBox = 0;
	tPropDlgItem.tMountItem.poFSysComboBox = 0;
	tPropDlgItem.tMountItem.poKeyFileFileChooser = 0;
	tPropDlgItem.tMountItem.poPlaceAfterComboBox = 0;
	
	poRefGlade->get_widget("PropDlgStatusVolumeLabelEntry", tPropDlgItem.tStatusItem.poVolumeLabelEntry);
	poRefGlade->get_widget("PropDlgStatusSourceEntry", tPropDlgItem.tStatusItem.poSourceEntry);
	poRefGlade->get_widget("PropDlgStatusMountPointEntry", tPropDlgItem.tStatusItem.poMountPointEntry);
	poRefGlade->get_widget("PropDlgStatusFSysEntry", tPropDlgItem.tStatusItem.poFSysEntry);
	poRefGlade->get_widget("PropDlgStatusDiskCapacityEntry", tPropDlgItem.tStatusItem.poDiskCapacityEntry);
	poRefGlade->get_widget("PropDlgStatusDiskUsedEntry", tPropDlgItem.tStatusItem.poDiskUsedEntry);
	poRefGlade->get_widget("PropDlgStatusDiskFreeEntry", tPropDlgItem.tStatusItem.poDiskFreeEntry);
	poRefGlade->get_widget("PropDlgStatusExtraTextView", tPropDlgItem.tStatusItem.poExtraTextView);
	
	poRefGlade->get_widget("PropDlgMountSourceVBox", tPropDlgItem.tMountItem.poSourceVBox);
	poRefGlade->get_widget("PropDlgMountMountPointFileChooser", tPropDlgItem.tMountItem.poMountPointFileChooser);
	poRefGlade->get_widget("PropDlgMountPermToggleButton", tPropDlgItem.tMountItem.poPermToggleButton);
	poRefGlade->get_widget("PropDlgMountVolumeLabelEntry", tPropDlgItem.tMountItem.poVolumeLabelEntry);
	poRefGlade->get_widget("PropDlgMountFSysVBox", tPropDlgItem.tMountItem.poFSysVBox);
	poRefGlade->get_widget("PropDlgMountReadOnlyCheckButton", tPropDlgItem.tMountItem.poReadOnlyCheckButton);
	poRefGlade->get_widget("PropDlgMountEncryptedCheckButton", tPropDlgItem.tMountItem.poEncryptedCheckButton);
	poRefGlade->get_widget("PropDlgMountUsePasswordRadioButton", tPropDlgItem.tMountItem.poUsePasswordRadioButton);
	poRefGlade->get_widget("PropDlgMountUseKeyFileRadioButton", tPropDlgItem.tMountItem.poUseKeyFileRadioButton);
	poRefGlade->get_widget("PropDlgMountKeyFileVBox", tPropDlgItem.tMountItem.poKeyFileVBox);
	poRefGlade->get_widget("PropDlgMountPlaceAfterVBox", tPropDlgItem.tMountItem.poPlaceAfterVBox);
	
	poRefGlade->get_widget("PropDlgCloneDestinationEntry", tPropDlgItem.tCloneItem.poDestinationEntry);
	poRefGlade->get_widget("PropDlgCloneDestinationButton", tPropDlgItem.tCloneItem.poDestinationButton);
	poRefGlade->get_widget("PropDlgCloneOverwriteCheckButton", tPropDlgItem.tCloneItem.poOverwriteCheckButton);
	
	poRefGlade->get_widget("PropDlgOptAutomountCheckButton", tPropDlgItem.tOptionsItem.poAutomountCheckButton);
	poRefGlade->get_widget("PropDlgOptEmptyTrashCheckButton", tPropDlgItem.tOptionsItem.poEmptyTrashCheckButton);
	poRefGlade->get_widget("PropDlgOptEmptyTrashConfirmCheckButton", tPropDlgItem.tOptionsItem.poEmptyTrashConfirmCheckButton);
	
	poRefGlade->get_widget("PropDlgApplyButton", tPropDlgItem.poApplyButton);
	poRefGlade->get_widget("PropDlgCloseButton", tPropDlgItem.poCloseButton);
}

//==============================================================================
